package org.alma.controllers;

import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.ChoiceBox;
import javafx.scene.control.ListView;
import javafx.scene.control.TextField;
import javafx.scene.text.Text;
import javafx.stage.Stage;

public class LobbyController {

    @FXML
    private ChoiceBox<String> nbPlayers;
    @FXML
    private TextField lobbyName;
    @FXML
    private Button createButton;
    @FXML
    private Text errorCreate;

    @FXML
    private ListView<String> listLobby;
    @FXML
    private Button joinButton;
    @FXML
    private Text errorJoin;

    public void init(){
        // Load the choice of the number of players
        ObservableList<String> players = FXCollections.observableArrayList("2 Players", "3 Players", "4 Players");
        this.nbPlayers.setItems(players);
        this.nbPlayers.setValue("Number of players");

        // Load lobby which can be joined
        ObservableList<String> lobby = FXCollections.observableArrayList("No lobby available");
        this.listLobby.setItems(lobby);
    }

    @FXML
    private void handleButtonCreate () throws Exception {
        if (!this.nbPlayers.getValue().equals("Number of players")) {
            if (!this.lobbyName.getText().equals("")){
                // TODO Launch the game

                // Get the stage of the game
                Stage stage = (Stage) this.createButton.getScene().getWindow();

                // Get and load the lobby view
                FXMLLoader fxmlLoader = new FXMLLoader(getClass().getResource("/view/game.fxml"));
                Scene scene = new Scene(fxmlLoader.load());

                // Get the controller of the lobby to init the view
                GameController controller = fxmlLoader.getController();
                controller.init();

                stage.setScene(scene);
                stage.show();
            }
            else {
                this.errorCreate.setText("The name of the lobby is empty");
            }
        }
        else {
            this.errorCreate.setText("The number of players is not selected");
        }

    }

    @FXML
    private void handleButtonJoin () throws Exception {
        if (!this.listLobby.getSelectionModel().getSelectedItems().isEmpty()) {
            if (!this.listLobby.getSelectionModel().getSelectedItem().equals("No lobby available")) {
            // TODO Join the lobby

            // Get the stage of the game
            Stage stage = (Stage) this.createButton.getScene().getWindow();

            // Get and load the lobby view
            FXMLLoader fxmlLoader = new FXMLLoader(getClass().getResource("/view/game.fxml"));
            Scene scene = new Scene(fxmlLoader.load());

            // Get the controller of the lobby to init the view
            GameController controller = fxmlLoader.getController();
            controller.init();

            stage.setScene(scene);
            stage.show();
            }
            else {
                this.errorJoin.setText("No lobby available to join");
            }
        }
        else {
            this.errorJoin.setText("No lobby selected");
        }
    }
}
